]> git.ipfire.org Git - thirdparty/git.git/blame - git-rebase.sh
GIT-VERSION-GEN: support non-standard $GIT_DIR path
[thirdparty/git.git] / git-rebase.sh
CommitLineData
59e6b23a
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano.
4#
5
533b7039 6SUBDIRECTORY_OK=Yes
45e2acf3
MZ
7OPTIONS_KEEPDASHDASH=
8OPTIONS_SPEC="\
c2145384 9git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
0cd993a7 10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
eb9a7cb4 11git-rebase --continue | --abort | --skip | --edit-todo
45e2acf3
MZ
12--
13 Available options are
14v,verbose! display a diffstat of what changed upstream
15q,quiet! be quiet. implies --no-stat
16onto=! rebase onto given branch instead of upstream
17p,preserve-merges! try to recreate merges instead of ignoring them
18s,strategy=! use the given merge strategy
19no-ff! cherry-pick all commits, even if unchanged
20m,merge! use merging strategies to rebase
21i,interactive! let the user edit the list of commits to rebase
c2145384 22x,exec=! add exec lines after each commit of the editable list
90e1818f 23k,keep-empty preserve empty commits during rebase
45e2acf3
MZ
24f,force-rebase! force rebase even if branch is up to date
25X,strategy-option=! pass the argument through to the merge strategy
26stat! display a diffstat of what changed upstream
27n,no-stat! do not show diffstat of what changed upstream
28verify allow pre-rebase hook to run
29rerere-autoupdate allow rerere to update index with resolved conflicts
30root! rebase all reachable commits up to the root(s)
31autosquash move commits that begin with squash!/fixup! under -i
32committer-date-is-author-date! passed to 'git am'
33ignore-date! passed to 'git am'
34whitespace=! passed to 'git apply'
35ignore-whitespace! passed to 'git apply'
36C=! passed to 'git apply'
37 Actions:
5960bc9d
MZ
38continue! continue
39abort! abort and check out the original branch
40skip! skip current patch and continue
eb9a7cb4 41edit-todo! edit the todo list during an interactive rebase
45e2acf3 42"
ae2b0f15 43. git-sh-setup
c7108bf9 44. git-sh-i18n
f9474132 45set_reflog_action rebase
035b5bf6 46require_work_tree_exists
533b7039 47cd_to_toplevel
4282c4fb 48
61dfa1bb
JH
49LF='
50'
6bb4e485
MZ
51ok_to_skip_pre_rebase=
52resolvemsg="
c7108bf9
JX
53$(gettext 'When you have resolved this problem, run "git rebase --continue".
54If you prefer to skip this patch, run "git rebase --skip" instead.
55To check out the original branch and stop rebasing, run "git rebase --abort".')
cc120056 56"
6bb4e485 57unset onto
c2145384 58cmd=
9765b6ab 59strategy=
93ce190c 60strategy_opts=
58634dbf 61do_merge=
69a636ad
MZ
62merge_dir="$GIT_DIR"/rebase-merge
63apply_dir="$GIT_DIR"/rebase-apply
b758789c 64verbose=
9474a029
MZ
65diffstat=
66test "$(git config --bool rebase.stat)" = true && diffstat=t
67dad687 67git_am_opt=
190f5323 68rebase_root=
b2f82e05 69force_rebase=
cb6020bb 70allow_rerere_autoupdate=
99de0640
MZ
71# Non-empty if a rebase was in progress when 'git rebase' was invoked
72in_progress=
73# One of {am, merge, interactive}
74type=
75# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
76state_dir=
34262322
MZ
77# One of {'', continue, skip, abort}, as parsed from command line
78action=
cf432ca0
MZ
79preserve_merges=
80autosquash=
90e1818f 81keep_empty=
cf432ca0 82test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
58634dbf 83
fa99c1e1 84read_basic_state () {
02ac45fa
MZ
85 head_name=$(cat "$state_dir"/head-name) &&
86 onto=$(cat "$state_dir"/onto) &&
84df4560
MZ
87 # We always write to orig-head, but interactive rebase used to write to
88 # head. Fall back to reading from head to cover for the case that the
89 # user upgraded git with an ongoing interactive rebase.
90 if test -f "$state_dir"/orig-head
2959c283 91 then
2959c283 92 orig_head=$(cat "$state_dir"/orig-head)
84df4560
MZ
93 else
94 orig_head=$(cat "$state_dir"/head)
2959c283 95 fi &&
7b37a7c6
MZ
96 GIT_QUIET=$(cat "$state_dir"/quiet) &&
97 test -f "$state_dir"/verbose && verbose=t
80ff4795
MZ
98 test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
99 test -f "$state_dir"/strategy_opts &&
100 strategy_opts="$(cat "$state_dir"/strategy_opts)"
b3e4847e
MZ
101 test -f "$state_dir"/allow_rerere_autoupdate &&
102 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
02ac45fa
MZ
103}
104
84df4560
MZ
105write_basic_state () {
106 echo "$head_name" > "$state_dir"/head-name &&
107 echo "$onto" > "$state_dir"/onto &&
108 echo "$orig_head" > "$state_dir"/orig-head &&
7b37a7c6
MZ
109 echo "$GIT_QUIET" > "$state_dir"/quiet &&
110 test t = "$verbose" && : > "$state_dir"/verbose
80ff4795
MZ
111 test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
112 test -n "$strategy_opts" && echo "$strategy_opts" > \
113 "$state_dir"/strategy_opts
b3e4847e
MZ
114 test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
115 "$state_dir"/allow_rerere_autoupdate
84df4560
MZ
116}
117
4974c2ca
MZ
118output () {
119 case "$verbose" in
120 '')
121 output=$("$@" 2>&1 )
122 status=$?
123 test $status != 0 && printf "%s\n" "$output"
124 return $status
125 ;;
126 *)
127 "$@"
128 ;;
129 esac
130}
131
6fd2f5e6 132move_to_original_branch () {
6fd2f5e6
JS
133 case "$head_name" in
134 refs/*)
135 message="rebase finished: $head_name onto $onto"
136 git update-ref -m "$message" \
137 $head_name $(git rev-parse HEAD) $orig_head &&
53f2ffa8
JK
138 git symbolic-ref \
139 -m "rebase finished: returning to $head_name" \
140 HEAD $head_name ||
c7108bf9 141 die "$(gettext "Could not move back to $head_name")"
6fd2f5e6
JS
142 ;;
143 esac
144}
145
fa99c1e1 146run_specific_rebase () {
f8cca019
AE
147 if [ "$interactive_rebase" = implied ]; then
148 GIT_EDITOR=:
149 export GIT_EDITOR
8a6dae10 150 autosquash=
f8cca019 151 fi
46df82d5 152 . git-rebase--$type
1b1dce4b
JS
153}
154
d70b4a8f 155run_pre_rebase_hook () {
6bb4e485 156 if test -z "$ok_to_skip_pre_rebase" &&
c4427656 157 test -x "$GIT_DIR/hooks/pre-rebase"
d70b4a8f 158 then
bc2bbc45 159 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
c7108bf9 160 die "$(gettext "The pre-rebase hook refused to rebase.")"
d70b4a8f
NS
161 fi
162}
163
69a636ad 164test -f "$apply_dir"/applying &&
c7108bf9 165 die "$(gettext "It looks like git-am is in progress. Cannot rebase.")"
9b752a6e 166
99de0640
MZ
167if test -d "$apply_dir"
168then
169 type=am
170 state_dir="$apply_dir"
171elif test -d "$merge_dir"
172then
173 if test -f "$merge_dir"/interactive
174 then
175 type=interactive
176 interactive_rebase=explicit
177 else
178 type=merge
179 fi
180 state_dir="$merge_dir"
181fi
182test -n "$type" && in_progress=t
183
95135b06 184total_argc=$#
822f7c73 185while test $# != 0
e646c9c8
JH
186do
187 case "$1" in
c4427656 188 --no-verify)
6bb4e485 189 ok_to_skip_pre_rebase=yes
c4427656 190 ;;
7baf9c4b 191 --verify)
6bb4e485 192 ok_to_skip_pre_rebase=
7baf9c4b 193 ;;
eb9a7cb4 194 --continue|--skip|--abort|--edit-todo)
45e2acf3 195 test $total_argc -eq 2 || usage
34262322 196 action=${1##--}
031321c6 197 ;;
e646c9c8
JH
198 --onto)
199 test 2 -le "$#" || usage
6bb4e485 200 onto="$2"
e646c9c8
JH
201 shift
202 ;;
c2145384
LK
203 -x)
204 test 2 -le "$#" || usage
205 cmd="${cmd}exec $2${LF}"
206 shift
207 ;;
45e2acf3 208 -i)
cf432ca0
MZ
209 interactive_rebase=explicit
210 ;;
90e1818f
NH
211 -k)
212 keep_empty=yes
213 ;;
45e2acf3 214 -p)
cf432ca0
MZ
215 preserve_merges=t
216 test -z "$interactive_rebase" && interactive_rebase=implied
217 ;;
218 --autosquash)
219 autosquash=t
220 ;;
221 --no-autosquash)
222 autosquash=
223 ;;
45e2acf3 224 -M|-m)
58634dbf
EW
225 do_merge=t
226 ;;
45e2acf3
MZ
227 -X)
228 shift
229 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$1")"
93ce190c 230 do_merge=t
9765b6ab 231 test -z "$strategy" && strategy=recursive
93ce190c 232 ;;
45e2acf3
MZ
233 -s)
234 shift
235 strategy="$1"
58634dbf
EW
236 do_merge=t
237 ;;
45e2acf3 238 -n)
a9c3821c
TAV
239 diffstat=
240 ;;
241 --stat)
242 diffstat=t
243 ;;
45e2acf3 244 -v)
b758789c 245 verbose=t
a9c3821c 246 diffstat=t
0e987a12
SB
247 GIT_QUIET=
248 ;;
45e2acf3 249 -q)
0e987a12
SB
250 GIT_QUIET=t
251 git_am_opt="$git_am_opt -q"
252 verbose=
253 diffstat=
b758789c 254 ;;
45e2acf3
MZ
255 --whitespace)
256 shift
257 git_am_opt="$git_am_opt --whitespace=$1"
b2f82e05 258 case "$1" in
45e2acf3 259 fix|strip)
b2f82e05
SR
260 force_rebase=t
261 ;;
262 esac
059f446d 263 ;;
86c91f91
GB
264 --ignore-whitespace)
265 git_am_opt="$git_am_opt $1"
266 ;;
570ccad3
MB
267 --committer-date-is-author-date|--ignore-date)
268 git_am_opt="$git_am_opt $1"
269 force_rebase=t
270 ;;
45e2acf3
MZ
271 -C)
272 shift
273 git_am_opt="$git_am_opt -C$1"
67dad687 274 ;;
190f5323
TR
275 --root)
276 rebase_root=t
277 ;;
45e2acf3 278 -f|--no-ff)
b2f82e05
SR
279 force_rebase=t
280 ;;
cb6020bb
JH
281 --rerere-autoupdate|--no-rerere-autoupdate)
282 allow_rerere_autoupdate="$1"
283 ;;
45e2acf3
MZ
284 --)
285 shift
e646c9c8
JH
286 break
287 ;;
288 esac
289 shift
290done
51b2ead0 291test $# -gt 2 && usage
2db8aaec 292
c2145384
LK
293if test -n "$cmd" &&
294 test "$interactive_rebase" != explicit
295then
465d6a00 296 die "$(gettext "The --exec option must be used with the --interactive option")"
c2145384
LK
297fi
298
cf432ca0
MZ
299if test -n "$action"
300then
c7108bf9 301 test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
2959c283
MZ
302 # Only interactive rebase uses detailed reflog messages
303 if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
304 then
305 GIT_REFLOG_ACTION="rebase -i ($action)"
306 export GIT_REFLOG_ACTION
307 fi
cf432ca0 308fi
34262322 309
eb9a7cb4
AW
310if test "$action" = "edit-todo" && test "$type" != "interactive"
311then
312 die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
313fi
314
34262322
MZ
315case "$action" in
316continue)
2959c283
MZ
317 # Sanity check
318 git rev-parse --verify HEAD >/dev/null ||
c7108bf9 319 die "$(gettext "Cannot read HEAD")"
34262322
MZ
320 git update-index --ignore-submodules --refresh &&
321 git diff-files --quiet --ignore-submodules || {
c7108bf9
JX
322 echo "$(gettext "You must edit all merge conflicts and then
323mark them as resolved using git add")"
34262322
MZ
324 exit 1
325 }
fa99c1e1
MZ
326 read_basic_state
327 run_specific_rebase
34262322
MZ
328 ;;
329skip)
4974c2ca 330 output git reset --hard HEAD || exit $?
fa99c1e1
MZ
331 read_basic_state
332 run_specific_rebase
34262322
MZ
333 ;;
334abort)
335 git rerere clear
fa99c1e1 336 read_basic_state
34262322
MZ
337 case "$head_name" in
338 refs/*)
ea69619c 339 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
c7108bf9 340 die "$(eval_gettext "Could not move back to \$head_name")"
34262322
MZ
341 ;;
342 esac
4974c2ca 343 output git reset --hard $orig_head
34262322
MZ
344 rm -r "$state_dir"
345 exit
346 ;;
eb9a7cb4
AW
347edit-todo)
348 run_specific_rebase
349 ;;
34262322
MZ
350esac
351
99de0640
MZ
352# Make sure no rebase is in progress
353if test -n "$in_progress"
7f4bd5d8 354then
c7108bf9
JX
355 state_dir_base=${state_dir##*/}
356 cmd_live_rebase="git rebase (--continue | --abort | --skip)"
357 cmd_clear_stale_rebase="rm -fr \"$state_dir\""
358 die "
359$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
e39beac6 360I wonder if you are in the middle of another rebase. If that is the
99de0640 361case, please try
c7108bf9 362 $cmd_live_rebase
99de0640 363If that is not the case, please
c7108bf9 364 $cmd_clear_stale_rebase
9b752a6e 365and run me again. I am stopping in case you still have something
c7108bf9 366valuable there.')"
7f4bd5d8
JH
367fi
368
df5df20c
CW
369if test -n "$rebase_root" && test -z "$onto"
370then
371 test -z "$interactive_rebase" && interactive_rebase=implied
372fi
373
cf432ca0
MZ
374if test -n "$interactive_rebase"
375then
376 type=interactive
377 state_dir="$merge_dir"
378elif test -n "$do_merge"
379then
380 type=merge
381 state_dir="$merge_dir"
382else
383 type=am
384 state_dir="$apply_dir"
385fi
386
190f5323
TR
387if test -z "$rebase_root"
388then
15a147e6
MZ
389 case "$#" in
390 0)
391 if ! upstream_name=$(git rev-parse --symbolic-full-name \
392 --verify -q @{upstream} 2>/dev/null)
393 then
394 . git-parse-remote
395 error_on_missing_default_upstream "rebase" "rebase" \
3c02396a 396 "against" "git rebase <branch>"
15a147e6
MZ
397 fi
398 ;;
399 *) upstream_name="$1"
400 shift
401 ;;
402 esac
190f5323 403 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
c7108bf9 404 die "$(eval_gettext "invalid upstream \$upstream_name")"
190f5323
TR
405 upstream_arg="$upstream_name"
406else
df5df20c
CW
407 if test -z "$onto"
408 then
409 empty_tree=`git hash-object -t tree /dev/null`
410 onto=`git commit-tree $empty_tree </dev/null`
411 squash_onto="$onto"
412 fi
190f5323
TR
413 unset upstream_name
414 unset upstream
f2b6a199 415 test $# -gt 1 && usage
46df82d5 416 upstream_arg=--root
190f5323 417fi
32d99544 418
a1bf91e0 419# Make sure the branch to rebase onto is valid.
6bb4e485 420onto_name=${onto-"$upstream_name"}
9f21e97d
NS
421case "$onto_name" in
422*...*)
423 if left=${onto_name%...*} right=${onto_name#*...} &&
424 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
425 then
426 case "$onto" in
427 ?*"$LF"?*)
c7108bf9 428 die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
9f21e97d
NS
429 ;;
430 '')
c7108bf9 431 die "$(eval_gettext "\$onto_name: there is no merge base")"
9f21e97d
NS
432 ;;
433 esac
434 else
c7108bf9 435 die "$(eval_gettext "\$onto_name: there is no merge base")"
9f21e97d
NS
436 fi
437 ;;
438*)
71786f54 439 onto=$(git rev-parse --verify "${onto_name}^0") ||
c7108bf9 440 die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
9f21e97d
NS
441 ;;
442esac
a1bf91e0 443
0cb06644
JH
444# If the branch to rebase is given, that is the branch we will rebase
445# $branch_name -- branch being rebased, or HEAD (already detached)
446# $orig_head -- commit object name of tip of the branch before rebasing
447# $head_name -- refs/heads/<that-branch> or "detached HEAD"
448switch_to=
59e6b23a 449case "$#" in
190f5323 4501)
0cb06644 451 # Is it "rebase other $branchname" or "rebase other $commit"?
190f5323
TR
452 branch_name="$1"
453 switch_to="$1"
0cb06644 454
190f5323 455 if git show-ref --verify --quiet -- "refs/heads/$1" &&
cb82a05d 456 orig_head=$(git rev-parse -q --verify "refs/heads/$1")
0cb06644 457 then
190f5323 458 head_name="refs/heads/$1"
cb82a05d 459 elif orig_head=$(git rev-parse -q --verify "$1")
0cb06644
JH
460 then
461 head_name="detached HEAD"
462 else
c7108bf9 463 die "$(eval_gettext "fatal: no such branch: \$branch_name")"
0cb06644 464 fi
e646c9c8 465 ;;
f2b6a199 4660)
0cb06644 467 # Do not need to switch branches, we are already on it.
bcf31618
JH
468 if branch_name=`git symbolic-ref -q HEAD`
469 then
0cb06644 470 head_name=$branch_name
bcf31618
JH
471 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
472 else
0cb06644 473 head_name="detached HEAD"
bcf31618
JH
474 branch_name=HEAD ;# detached
475 fi
cb82a05d 476 orig_head=$(git rev-parse --verify "${branch_name}^0") || exit
e646c9c8 477 ;;
f2b6a199
MZ
478*)
479 die "BUG: unexpected number of arguments left to parse"
480 ;;
59e6b23a
JH
481esac
482
c7108bf9 483require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
8f9bfb64 484
cb82a05d
MZ
485# Now we are rebasing commits $upstream..$orig_head (or with --root,
486# everything leading up to $orig_head) on top of $onto
e646c9c8 487
1308c17b 488# Check if we are already based on $onto with linear history,
cc1453e1
MZ
489# but this should be done only when upstream and onto are the same
490# and if this is not an interactive rebase.
cb82a05d 491mb=$(git merge-base "$onto" "$orig_head")
cc1453e1
MZ
492if test "$type" != interactive && test "$upstream" = "$onto" &&
493 test "$mb" = "$onto" &&
1308c17b 494 # linear history?
cb82a05d 495 ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
7f4bd5d8 496then
b2f82e05
SR
497 if test -z "$force_rebase"
498 then
499 # Lazily switch to the target branch if needed...
3b21a438 500 test -z "$switch_to" || git checkout "$switch_to" --
c7108bf9 501 say "$(eval_gettext "Current branch \$branch_name is up to date.")"
b2f82e05
SR
502 exit 0
503 else
c7108bf9 504 say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
b2f82e05 505 fi
7f4bd5d8
JH
506fi
507
8f9bfb64
MZ
508# If a hook exists, give it a chance to interrupt
509run_pre_rebase_hook "$upstream_arg" "$@"
510
a9c3821c
TAV
511if test -n "$diffstat"
512then
513 if test -n "$verbose"
514 then
c7108bf9 515 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
a9c3821c
TAV
516 fi
517 # We want color (if set), but no pager
518 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
519fi
520
fa99c1e1 521test "$type" = interactive && run_specific_rebase
f4107d9c
MZ
522
523# Detach HEAD and reset the tree
c7108bf9 524say "$(gettext "First, rewinding head to replay your work on top of it...")"
f4107d9c 525git checkout -q "$onto^0" || die "could not detach HEAD"
cb82a05d 526git update-ref ORIG_HEAD $orig_head
f4107d9c 527
e646c9c8 528# If the $onto is a proper descendant of the tip of the branch, then
a75d7b54 529# we just fast-forwarded.
cb82a05d 530if test "$mb" = "$orig_head"
32d99544 531then
c7108bf9 532 say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
6fd2f5e6 533 move_to_original_branch
32d99544
LS
534 exit 0
535fi
536
190f5323
TR
537if test -n "$rebase_root"
538then
539 revisions="$onto..$orig_head"
540else
541 revisions="$upstream..$orig_head"
542fi
543
fa99c1e1 544run_specific_rebase